<?
	/*
	 * Eventmanager - Manage and organize events, meetings, partys online 
	 * Copyright (C) 2006 
	 * Sven O. Gabel - Sven.O.Gabel@dynamicvisions.de
	 * 
	 * This program is free software; you can redistribute it and/or modify it under the terms of 
	 * the GNU General Public License as published by the Free Software Foundation; either 
	 * version 2 of the License, or (at your option) any later version.
	 * This program is distributed in the hope that it will be useful, 
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
	 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
	 * 
	 * You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA 
	 * 
	 */
?>
<?php
/*
	This SQL query will create the table to store your object.

	CREATE TABLE `rolle` (
	`rolleid` int(11) auto_increment,
	`name` VARCHAR(255),
	`default` SMALLINT, PRIMARY KEY  (`rolleid`));
*/

/**
* <b>Rolle</b> class with integrated CRUD methods.
* @author Php Object Generator
* @version 1.6 rc1
* @copyright Free for personal & commercial use. (Offered under the BSD license)
* @link http://www.phpobjectgenerator.com/?language=php4&wrapper=pog&objectName=Rolle&attributeList=array+%28%0A++0+%3D%3E+%27name%27%2C%0A++1+%3D%3E+%27default%27%2C%0A%29&typeList=array+%28%0A++0+%3D%3E+%27VARCHAR%28255%29%27%2C%0A++1+%3D%3E+%27SMALLINT%27%2C%0A%29
*/
class Rolle
{
	var $rolleId;
	var $name;
	var $default;
	var $pog_attribute_type = array(
		"rolleid" => array("NUMERIC", "INT"),
		"name" => array("TEXT", "VARCHAR", "255"),
		"default" => array("NUMERIC", "SMALLINT"),
		);
	var $pog_query;
	
	function Rolle($name='', $default='')
	{
		$this->name = $name;
		$this->default = $default;
	}
	
	
	/**
	* Gets object from database
	* @param integer $rolleId 
	* @return object $Rolle
	*/
	function Get($rolleId)
	{
		$Database = new DatabaseConnection();
		$this->pog_query = "select * from `rolle` where `rolleid`='".intval($rolleId)."' LIMIT 1";
		$Database->Query($this->pog_query);
		$this->rolleId = $Database->Result(0, "rolleid");
		$this->name = $Database->Unescape($Database->Result(0, "name"));
		$this->default = $Database->Unescape($Database->Result(0, "default"));
		return $this;
	}
	
	function GetRolleByName($rolleName) {
		$rolleListe = $this->GetList(array(array("name","=",$rolleName)));
		if(sizeOf($rolleListe)>0)
			return $rolleListe[0];	
		return NULL;
	}
	
	/**
	* Returns a sorted array of objects that match given conditions
	* @param multidimensional array {("field", "comparator", "value"), ("field", "comparator", "value"), ...} 
	* @param string $sortBy 
	* @param boolean $ascending 
	* @param int limit 
	* @return array $rolleList
	*/
	function GetList($fcv_array, $sortBy='', $ascending=true, $limit='')
	{
		$sqlLimit = ($limit != '' && $sortBy == ''?"LIMIT $limit":'');
		if (sizeof($fcv_array) > 0)
		{
			$rolleList = Array();
			$Database = new DatabaseConnection();
			$this->pog_query = "select rolleid from `rolle` where ";
			for ($i=0, $c=sizeof($fcv_array)-1; $i<$c; $i++)
			{
				$this->pog_query .= "`".strtolower($fcv_array[$i][0])."` ".$fcv_array[$i][1]." '".$Database->Escape($fcv_array[$i][2])."' AND";
			}
			$this->pog_query .= "`".strtolower($fcv_array[$i][0])."` ".$fcv_array[$i][1]." '".$Database->Escape($fcv_array[$i][2])."' order by rolleid asc $sqlLimit";
			$Database->Query($this->pog_query);
			for ($i=0; $i < $Database->Rows(); $i++)
			{
				$rolle = new Rolle();
				$rolle->Get($Database->Result($i, "rolleid"));
				$rolleList[] = $rolle;
			}
			if ($sortBy != '')
			{
				$f = '';
				$rolle = new Rolle();
				if (isset($rolle->pog_attribute_type[strtolower($sortBy)]) && $rolle->pog_attribute_type[strtolower($sortBy)][0] == "NUMERIC")
				{
					$f = 'return $rolle1->'.$sortBy.' > $rolle2->'.$sortBy.';';
				}
				else if (isset($rolle->pog_attribute_type[strtolower($sortBy)]))
				{
					$f = 'return strcmp(strtolower($rolle1->'.$sortBy.'), strtolower($rolle2->'.$sortBy.'));';
				}
				usort($rolleList, create_function('$rolle1, $rolle2', $f));
				if (!$ascending)
				{
					$rolleList = array_reverse($rolleList);
				}
				if ($limit != '')
				{
					return array_slice($rolleList, 0, $limit);
				}
			}
			return $rolleList;
		}
		return null;
	}
	
	
	/**
	* Saves the object to the database
	* @return integer $rolleId
	*/
	function Save()
	{
		$Database = new DatabaseConnection();
		$this->pog_query = "select rolleid from `rolle` where `rolleid`='".$this->rolleId."' LIMIT 1";
		$Database->Query($this->pog_query);
		if ($Database->Rows() > 0)
		{
			$this->pog_query = "update `rolle` set 
			`name`='".$Database->Escape($this->name)."', 
			`default`='".$Database->Escape($this->default)."' where `rolleid`='".$this->rolleId."'";
		}
		else
		{
			$this->pog_query = "insert into `rolle` (`name`, `default` ) values (
			'".$Database->Escape($this->name)."', 
			'".$Database->Escape($this->default)."' )";
		}
		$Database->InsertOrUpdate($this->pog_query);
		if ($this->rolleId == "")
		{
			$this->rolleId = $Database->GetCurrentId();
		}
		return $this->rolleId;
	}
	
	
	/**
	* Clones the object and saves it to the database
	* @return integer $rolleId
	*/
	function SaveNew()
	{
		$this->rolleId = '';
		return $this->Save();
	}
	
	
	/**
	* Deletes the object from the database
	* @return boolean
	*/
	function Delete()
	{
		$Database = new DatabaseConnection();
		$this->pog_query = "delete from `rolle` where `rolleid`='".$this->rolleId."'";
		return $Database->Query($this->pog_query);
	}
	
	//Return a Right contained in this role by name
	function GetRechtByKey($rechtKey) {
		$array_rechte = $this->GetRechte();
		for($i=0;$i<sizeof($array_rechte);$i++) {
			$entity_recht = $array_rechte[$i];
			if($rechtKey==$entity_recht->key) {
				return $entity_recht;
			}	
		}
		return NULL;	
	}
	
	function DeleteCascading() {
		$entity_recht2rolle = new Recht2Rolle();
		
		$recht2rolleListe = $entity_recht2rolle->GetList(array(array("rolle_fk","=",$this->rolleId)));
		
		for ($i=0; $i<sizeof($recht2rolleListe); $i++)
		{
			$recht2rolleListe[$i]->Delete();			
		}
		$this->Delete();
	}
	
	function GetRechte() {
		
		$entity_recht2rolle = new Recht2Rolle();
		$entity_recht = new Recht();
		$rechtListe = Array();
		
		$recht2rolleListe = $entity_recht2rolle->GetList(array(array("rolle_fk","=",$this->rolleId)));
		
		for ($i=0; $i<sizeof($recht2rolleListe); $i++)
		{
			$entity_recht=$entity_recht->Get($recht2rolleListe[$i]->recht_fk);
			array_push($rechtListe,$entity_recht); 
		}
		return $rechtListe;
	}
	
	function removeRecht($rechtid) {
		$entity_recht2rolle = new Recht2Rolle();
		$recht2rolleListe = $entity_recht2rolle->GetList(array(array("rolle_fk","=",$this->rolleId),array("recht_fk","=",$rechtid)));
		#sollte nur ein Ergebnis enthalte
		if(sizeOf($recht2rolleListe)==0)
			return;
		$recht2rolleListe[0]->Delete();		
	}
	
	function addRecht($rechtid) {
		$entity_recht2rolle = new Recht2Rolle();
		$entity_recht2rolle->recht_fk= $rechtid;
		$entity_recht2rolle->rolle_fk= $this->rolleId;
		$entity_recht2rolle->SaveNew();	
	}
	
	function getDefault() {
		$defaults = $this->GetList(array(array("default","=",1)));
		if(sizeOf($defaults)>0)
			return $defaults[0];
		return null;	
	}
	
	function getUsers() {
		$entity_user2rolle = new User2Rolle();
		$entity_user = new user();
		$userListe = Array();
		$user2rolleListe = $entity_user2rolle->GetList(array(array("rolle_fk","=",$this->rolleId)));
		for ($i=0; $i<sizeof($user2rolleListe); $i++)
		{
			$entity_rolle=$entity_user->Get($user2rolleListe[$i]->user_fk);
			array_push($userListe,$entity_rolle); 
		}
		return $userListe;
	}
		
}
?>