<?
	/*
	 * Eventmanager - Manage and organize events, meetings, partys online 
	 * Copyright (C) 2006 
	 * Sven O. Gabel - Sven.O.Gabel@dynamicvisions.de
	 * 
	 * This program is free software; you can redistribute it and/or modify it under the terms of 
	 * the GNU General Public License as published by the Free Software Foundation; either 
	 * version 2 of the License, or (at your option) any later version.
	 * This program is distributed in the hope that it will be useful, 
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
	 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
	 * 
	 * You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA 
	 * 
	 */
?>
<?php
include_once("class.user2rolle.php");
include_once("class.rolle.php");
include_once("class.recht.php");
include_once("class.recht2rolle.php");

/*
	This SQL query will create the table to store your object.

	CREATE TABLE `user` (
	`userid` int(11) auto_increment,
	`name` BIGINT,
	`password` BIGINT,
	`email` VARCHAR(255),
	`status` INT,
	`allowemailnotification` SMALLINT, PRIMARY KEY  (`userid`));
*/

/**
* <b>User</b> class with integrated CRUD methods.
* @author Php Object Generator
* @version 1.6 rc1
* @copyright Free for personal & commercial use. (Offered under the BSD license)
* @link http://www.phpobjectgenerator.com/?language=php4&wrapper=pog&objectName=User&attributeList=array+%28%0A++0+%3D%3E+%27name%27%2C%0A++1+%3D%3E+%27password%27%2C%0A++2+%3D%3E+%27email%27%2C%0A++3+%3D%3E+%27status%27%2C%0A++4+%3D%3E+%27allowemailnotification%27%2C%0A%29&typeList=array+%28%0A++0+%3D%3E+%27BIGINT%27%2C%0A++1+%3D%3E+%27BIGINT%27%2C%0A++2+%3D%3E+%27VARCHAR%28255%29%27%2C%0A++3+%3D%3E+%27INT%27%2C%0A++4+%3D%3E+%27SMALLINT%27%2C%0A%29
*/
class User
{
	var $FINAL=1;
	var $PREPARED=0;
	var $userId;
	var $name;
	var $password;
	var $email;
	var $status;
	var $allowemailnotification;
	var $pog_attribute_type = array(
		"userid" => array("NUMERIC", "INT"),
		"name" => array("VARCHAR", "255"),
		"password" => array("VARCHAR", "255"),
		"email" => array("TEXT", "VARCHAR", "255"),
		"status" => array("NUMERIC", "INT"),
		"allowemailnotification" => array("NUMERIC", "SMALLINT"),
		);
	var $pog_query;
	
	function User($name='', $password='', $email='', $status='', $allowemailnotification='')
	{
		$this->name = $name;
		$this->password = $password;
		$this->email = $email;
		$this->status = $status;
		$this->allowemailnotification = $allowemailnotification;
	}
	
	
	/**
	* Gets object from database
	* @param integer $userId 
	* @return object $User
	*/
	function Get($userId)
	{
		$Database = new DatabaseConnection();
		$this->pog_query = "select * from `user` where `userid`='".intval($userId)."' LIMIT 1";
		$Database->Query($this->pog_query);
		$this->userId = $Database->Result(0, "userid");
		$this->name = $Database->Unescape($Database->Result(0, "name"));
		$this->password = $Database->Unescape($Database->Result(0, "password"));
		$this->email = $Database->Unescape($Database->Result(0, "email"));
		$this->status = $Database->Unescape($Database->Result(0, "status"));
		$this->allowemailnotification = $Database->Unescape($Database->Result(0, "allowemailnotification"));
		return $this;
	}
	
	
	/**
	* Returns a sorted array of objects that match given conditions
	* @param multidimensional array {("field", "comparator", "value"), ("field", "comparator", "value"), ...} 
	* @param string $sortBy 
	* @param boolean $ascending 
	* @param int limit 
	* @return array $userList
	*/
	function GetList($fcv_array, $sortBy='', $ascending=true, $limit='')
	{
		$sqlLimit = ($limit != '' && $sortBy == ''?"LIMIT $limit":'');
		if (sizeof($fcv_array) > 0)
		{
			$userList = Array();
			$Database = new DatabaseConnection();
			$this->pog_query = "select userid from `user` where ";
			for ($i=0, $c=sizeof($fcv_array)-1; $i<$c; $i++)
			{
				$this->pog_query .= "`".strtolower($fcv_array[$i][0])."` ".$fcv_array[$i][1]." '".$Database->Escape($fcv_array[$i][2])."' AND";
			}
			$this->pog_query .= "`".strtolower($fcv_array[$i][0])."` ".$fcv_array[$i][1]." '".$Database->Escape($fcv_array[$i][2])."' order by userid asc $sqlLimit";
			$Database->Query($this->pog_query);
			for ($i=0; $i < $Database->Rows(); $i++)
			{
				$user = new User();
				$user->Get($Database->Result($i, "userid"));
				$userList[] = $user;
			}
			if ($sortBy != '')
			{
				$f = '';
				$user = new User();
				if (isset($user->pog_attribute_type[strtolower($sortBy)]) && $user->pog_attribute_type[strtolower($sortBy)][0] == "NUMERIC")
				{
					$f = 'return $user1->'.$sortBy.' > $user2->'.$sortBy.';';
				}
				else if (isset($user->pog_attribute_type[strtolower($sortBy)]))
				{
					$f = 'return strcmp(strtolower($user1->'.$sortBy.'), strtolower($user2->'.$sortBy.'));';
				}
				usort($userList, create_function('$user1, $user2', $f));
				if (!$ascending)
				{
					$userList = array_reverse($userList);
				}
				if ($limit != '')
				{
					return array_slice($userList, 0, $limit);
				}
			}
			return $userList;
		}
		return null;
	}
	
	
	/**
	* Saves the object to the database
	* @return integer $userId
	*/
	function Save()
	{
		$Database = new DatabaseConnection();
		$this->pog_query = "select userid from `user` where `userid`='".$this->userId."' LIMIT 1";
		$Database->Query($this->pog_query);
		if ($Database->Rows() > 0)
		{
			$this->pog_query = "update `user` set 
			`name`='".$Database->Escape($this->name)."', 
			`password`='".$Database->Escape($this->password)."', 
			`email`='".$Database->Escape($this->email)."', 
			`status`='".$Database->Escape($this->status)."', 
			`allowemailnotification`='".$Database->Escape($this->allowemailnotification)."' where `userid`='".$this->userId."'";
		}
		else
		{
			$this->pog_query = "insert into `user` (`name`, `password`, `email`, `status`, `allowemailnotification` ) values (
			'".$Database->Escape($this->name)."', 
			'".$Database->Escape($this->password)."', 
			'".$Database->Escape($this->email)."', 
			'".$Database->Escape($this->status)."', 
			'".$Database->Escape($this->allowemailnotification)."' )";
		}
		$Database->InsertOrUpdate($this->pog_query);
		if ($this->userId == "")
		{
			$this->userId = $Database->GetCurrentId();
		}
		return $this->userId;
	}
	
	
	/**
	* Clones the object and saves it to the database
	* @return integer $userId
	*/
	function SaveNew()
	{
		$this->userId = '';
		return $this->Save();
	}
	
	
	/**
	* Deletes the object from the database
	* @return boolean
	*/
	function Delete()
	{
		$Database = new DatabaseConnection();
		$this->pog_query = "delete from `user` where `userid`='".$this->userId."'";
		return $Database->Query($this->pog_query);
	}
	
	function GetRollen() {
		
		$entity_user2rolle = new User2Rolle();
		$entity_rolle = new Rolle();
		$rollenListe = Array();
		$user2rolleListe = $entity_user2rolle->GetList(array(array("user_fk","=",$this->userId)));
		for ($i=0; $i<sizeof($user2rolleListe); $i++)
		{
			#echo '<br>current user:'.$this->userId;
			#echo '<br>hole:'.$user2rolleListe[$i]->user2rolleId;
			$entity_rolle=$entity_rolle->Get($user2rolleListe[$i]->rolle_fk);
			#echo '<br>rolle:'.$entity_rolle->rolleId;
			array_push($rollenListe,$entity_rolle); 
		}
		return $rollenListe;
	}
	
	function removeRolle($rolleid) {
		$entity_user2rolle = new User2Rolle();
		$user2rolleListe = $entity_user2rolle->GetList(array(array("user_fk","=",$this->userId),array("rolle_fk","=",$rolleid)));
		#sollte nur ein Ergebnis enthalte
		if(sizeOf($user2rolleListe)==0)
			return;
		$user2rolleListe[0]->Delete();		
	}
	
	function addRolle($rolleid) {
		$entity_user2rolle= new User2Rolle();
		$entity_user2rolle->user_fk= $this->userId;
		$entity_user2rolle->rolle_fk= $rolleid;
		//print_r($entity_user2rolle);
		$entity_user2rolle->SaveNew();
	}
	
	function getAllUsers() {
		return $this->GetList(array(array("userId",">","0")));
	}
	
	//returns the first role found by name for this user
	//will not care about more than one occurence of a rolename
	//because of that,not guaranted,that the right role will be returned
	function getRoleOfUserByRoleName($rolename) {
		$array_alleRollen=$this->GetRollen();
		for($i=0;$i<sizeof($array_alleRollen);$i++) {
			$entity_rolle = $array_alleRollen[$i];
			if($rolename==$entity_rolle->name) {
				return $entity_rolle;
			}
		}
		return NULL;
	}
}
?>